//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaVtkStreamLineNumeration.h"
#include "bbcreaVtkPackage.h"

#include <vtkCellArray.h>
#include <vtkPointData.h>
#include <vtkDoubleArray.h>
#include <vtkPolyData.h>
#include "vtkIdList.h"

namespace bbcreaVtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaVtk,StreamLineNumeration)
BBTK_BLACK_BOX_IMPLEMENTATION(StreamLineNumeration,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void StreamLineNumeration::Process()
{

// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')

	std::string namascalararray="creaNumeration";

	if (bbGetInputStreamLinesIn()!=NULL)
	{
		vtkIdList 		*_vtkidlist 		= vtkIdList::New();
		vtkCellArray 	*vtkcellarray 		= bbGetInputStreamLinesIn()->GetLines();
		long int 		nLinesCell 			= vtkcellarray->GetNumberOfCells(); 
		long int 		ii,iLine;
		long int 		numberofids;


		vtkDoubleArray	*numeration 			= vtkDoubleArray::New();
		numeration->SetName( namascalararray.c_str() );  		
		numeration->SetNumberOfComponents(1); 
		numeration->SetNumberOfTuples(nLinesCell);

  		// FOR EACH LINE
  	 	ii=0;
  	 	for ( iLine=0 ; iLine<nLinesCell ; iLine++ )
  	 	{
			vtkcellarray->GetCell(ii, _vtkidlist );
			numberofids = _vtkidlist->GetNumberOfIds();
			numeration->SetTuple1(iLine, numberofids);
			ii=ii+numberofids+1;
  	 	} // for iLine

  		bbGetInputStreamLinesIn()->GetPointData()->AddArray( numeration );
	} // if bbGetInputStreamLinesIn()

	bbSetOutputStreamLinesOut( bbGetInputStreamLinesIn() );
	bbSetOutputNameOfScalarArray( namascalararray );
    
}

//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void StreamLineNumeration::bbUserSetDefaultValues()
{
//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
	bbSetInputStreamLinesIn( NULL );

}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void StreamLineNumeration::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void StreamLineNumeration::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
  
}
}
// EO namespace bbcreaVtk


