//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaVtkVectorPolyDataReader.h"
#include "bbcreaVtkPackage.h"

#include <vtkPolyDataReader.h>

namespace bbcreaVtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaVtk,VectorPolyDataReader)
BBTK_BLACK_BOX_IMPLEMENTATION(VectorPolyDataReader,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void VectorPolyDataReader::Process()
{

// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')


 	 std::vector<vtkPolyData*> vecPolyData;
	 std::string tmpFileName;

    int i,size=bbGetInputFileNameVector().size();
	 for (i=0;i<size; i++)
    {
       vtkPolyDataReader *reader = vtkPolyDataReader::New();
		 tmpFileName=bbGetInputDirName() + "/" + bbGetInputFileNameVector()[i];
		 reader->SetFileName( tmpFileName.c_str() );
       reader->ReadAllScalarsOn();
       reader->ReadAllVectorsOn();
       reader->ReadAllNormalsOn();
       reader->ReadAllTensorsOn();
       reader->ReadAllColorScalarsOn ();
       reader->ReadAllTCoordsOn();
       reader->ReadAllFieldsOn();
       reader->Update();
       vecPolyData.push_back( reader->GetOutput() );
    }
	
    bbSetOutputPolyDataVector( vecPolyData );
  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void VectorPolyDataReader::bbUserSetDefaultValues()
{

//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0

   bbSetInputDirName("");
  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void VectorPolyDataReader::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void VectorPolyDataReader::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
  
}
}
// EO namespace bbcreaVtk


